* Distribuzioni del reddito;

* "Attacco" il reddito equivalente a tutti gli individui;

Data all (keep = RB010 RB020 RB030 HB030 RB050);set lab_sas.lux_r_file;
HB030=RX030; * serve per fare il merge;
run;

data lux_all;merge all lab_sas.Lux_h_file (keep = HB030 HX080 HX090);
by HB030;
run;


* Distribuzione log-normale;

data lux_all;set lux_all;
log_y=log(HX090);
run;

proc univariate data=lux_all;
var HX090 log_y;
where log_y ne .;
weight RB050;
run;


* Distribuzione di Pareto;

proc sort data=lux_all;by HX090;run;
proc iml;use lux_all;
read all var {RB030} into RB030;
read all var {HX090} into HX090;
read all var {RB050} into w;

num=nrow(RB030); 
F=repeat(1,num); 
tot=sum(w);

 i=1;  do while (i<num);
       flag_i= HX090 < HX090[i];
       F[i]=sum(w#flag_i)/tot; 
	   
 i=i+1;  end;
create F var {RB030 HX090 w F };append ;close F;
run;


data Pareto;set F;
G=1-F;
log_g=log(G);
log_y=log(HX090);
run;

proc reg data=Pareto;
model log_g = log_y;
where log_g ne . and log_y ne . ;
weight w;
run;



*Povert familiare e individuale;

proc freq data=eq_inc;
table HX080;
run;

proc freq data=lux_all;
table HX080;
run;

proc freq data=lux_all;
table HX080;
weight RB050;
run;

* INDICATORI di LAEKEN;


*********************************1. HCR P.L.as 60% median;
%macro stat1;
data input_bound;set working;run;
%perc_bound(50);
data working1;merge working output_bound;by country;line=0.60*y_perc; 
if eqinc gt line then z=0;if eqinc le line then z=1;run;
proc univariate data=working1 noprint;output out=est mean=est;var z;weight w;by country;run;
data jrr;merge working1 est;by country;y=z-est;subpop_i=1;run;
title 'stat1';
%mend;

*************************2. HCR P.L.as 60% median before social transfer including pensions;
%macro stat2;
data input_bound;set working (drop=eqinc); eqinc=eqhy022; run;
data working1;merge working output_bound;by country;line=0.60*y_perc; 
if eqhy022 gt line then z=0;if eqhy022 le line then z=1;run;
proc univariate data=working1 noprint;output out=est mean=est;var z;weight w;by country;run;
data jrr;merge working1 est;by country;y=z-est;subpop_i=1;run;
title 'stat2';
%mend;


*************************3. HCR P.L.as 60% median before social transfer excluding pensions;
%macro stat3;
data input_bound;set working (drop=eqinc); eqinc=eqhy023; run;
data working1;merge working output_bound;by country;line=0.60*y_perc; 
if eqhy023 gt line then z=0;if eqhy023 le line then z=1;run;
proc univariate data=working1 noprint;output out=est mean=est;var z;weight w;by country;run;
data jrr;merge working1 est;by country;y=z-est;subpop_i=1;run;
title 'stat3';
%mend;


*********************************4. P(50) Median equivalised disposable income;
%macro stat4;
data input_bound;set working;run;
%perc_bound(50);
data jrr;merge working output_bound;by country;subpop_i=1;z=y_perc;y=1; run;
title 'stat4';
%mend;


********************************5. at-risk-of-poverty threshold;
%macro stat5;
data input_bound;set working;run;
%perc_bound(50);
data jrr;merge working output_bound;by country;y=1;z=0.60*y_perc;;subpop_i=1;run;
title 'stat5';
%mend;

*****************************6. S80/S20: ratio of income shares of the percentiles;
%macro stat6; 
data working;set working;  run;
data input_bound;set working;run;
%perc_bound(80);
data output_bound_80;set output_bound;rename y_perc=y_perc_80;run;
%perc_bound(20);
proc means data=working noprint; output out=media mean=media;var eqinc;weight w;by country;run;
data working1;merge working output_bound output_bound_80 media;by country;
alfai_80=sign(max(0,(eqinc-y_perc_80)));alfai_20=1-sign(max(0,(eqinc-y_perc)));
z_80=(eqinc/media)*alfai_80;z_20=(eqinc/media)*alfai_20;run;
proc univariate data=working1 noprint; output out=est mean=est_80 mean=est_20;
var z_80 z_20;weight w;by country;run;
data jrr;merge working1 est;by country;subpop_i=1;z=est_80/est_20;
y=(1/est_20)*(eqinc/media)*(alfai_80-z*alfai_20);run;
title 'stat6';
%mend;

*****************************7. Relative median at-risk-of-poverty gap;
%macro stat7;
data input_bound;set working;run;
%perc_bound(50);
data working1; merge working output_bound;by country;pov_l1=0.60*y_perc; 
if eqinc gt pov_l1 then pov1=0;if eqinc le pov_l1 then pov1=1;run;
data input_bound;set working1; where pov1=1;run;
%perc_bound(50);
data output_bound_p1;set output_bound; rename y_perc=y_perc_p;run;
data jrr;merge working1 output_bound_p1; by country;
z=((pov_l1-y_perc_p)/pov_l1);subpop_i=pov1;z1=z;y=1;run;
title 'stat7';
%mend;

***********************8. median income below the at-risk-of-poverty threshold;
%macro stat8; 
data input_bound;set working; run;
%perc_bound(50);
data working1;merge working output_bound;by country;line=0.60*y_perc; 
if eqinc gt line then pov1=0;if eqinc le line then pov1=1;z=eqinc;run;
data input_bound;set working1; where pov1=1;run;
%perc_bound(50);
data jrr;merge working1 output_bound;by country;y=y_perc;subpop_i=pov1;run;
title 'stat8';
%mend;


************************************9. HCR P.L.as 50% median;
%macro stat9;
data input_bound;set working;run;
%perc_bound(50);
data working1;merge working output_bound;by country;line=0.50*y_perc; 
if eqinc gt line then z=0;if eqinc le line then z=1;run;
proc univariate data=working1 noprint;output out=est mean=est;var z;weight w;by country;run;
data jrr;merge working1 est;by country;y=z-est;subpop_i=1;run;
title 'stat9';
%mend;

***********************************10. HCR P.L.as 70% median;
%macro stat10;
data input_bound;set working;run;
%perc_bound(50);
data working1;merge working output_bound;by country;line=0.70*y_perc; 
if eqinc gt line then z=0;if eqinc le line then z=1;run;
proc univariate data=working1 noprint;output out=est mean=est;var z;weight w;by country;run;
data jrr;merge working1 est;by country;y=z-est;subpop_i=1;run;
title 'stat10';
%mend;

*************************************11. HCR P.L.as 40% median;
%macro stat11;
data input_bound;set working;run;
%perc_bound(50);
data working1;merge working output_bound;by country;line=0.40*y_perc; 
if eqinc gt line then z=0;if eqinc le line then z=1;run;
proc univariate data=working1 noprint;output out=est mean=est;var z;weight w;by country;run;
data jrr;merge working1 est;by country;y=z-est;subpop_i=1;run;
title 'stat11';
%mend;


*****************************12. Gini;
%macro stat12; 
data working; set working; run;
proc means data=working noprint; output out=media mean=media;var eqinc;weight w;by country;run;
data media;set media (keep = media country);run;
proc sort data=working;by eqinc;run;
proc iml;use working;read all var {pid} into pid;read all var {w} into weig;read all var {eqinc} into eqinc;
num=nrow(pid); share_w=repeat(0,num);share_inc=repeat(0,num);eqinc_w=eqinc#weig;
tot_w=sum(weig);tot_inc=sum(eqinc_w);
 i=1;  do while (i<num+1);
         share_inc[i]=sum(eqinc_w[1:i])/tot_inc;
         share_w[i]=sum(weig[1:i])/tot_w;
 i=i+1;  end;
create share var {pid share_inc share_w};append;close share;quit;run;
proc sort data=working;by pid;run;proc sort data=share;by pid;run;
data working1;merge working share;by pid;run;
data working2;merge working1 media;by country;z=2*((eqinc-media)/media)*share_w;run;
proc univariate data=working2 noprint;output out=est mean=est;var z;weight w;by country;run;
data jrr;merge working2 est;by country;y=(2*((eqinc-media)/media)*share_w)-est;subpop_i=1;run;
title 'stat12';
%mend;


****************************************13. Mean equivalised income;
%macro stat13; 
data working1;set working;run;
proc means data=working1 noprint;output out=est mean=est;var eqinc;weight w;by country;run;
data JRR; merge working1 est;by country;subpop_i=1;y=eqinc-est;z=eqinc;run;
title 'stat13';
%mend;

************************************************Perc bound;
%macro perc_bound (perc);
data input;set input_bound;percent=&perc;run;
proc sort data=input;by eqinc;run;
proc iml;
use input;read all var {pid} into pid;read all var {w} into w;
read all var {eqinc} into eqinc;read all var {percent} into percent;
read all var {country} into country_vec;
num=nrow(pid); share=repeat(0,num);ratio=percent[1]/100;
tot=sum(w);
 i=2; do while (i<num+ 1);
      share[i]=sum(w[1:i])/tot;
	  if (share[i-1] < ratio) & (share[i] >= ratio)
      then y_perc=eqinc[i-1]+(eqinc[i]-eqinc[i-1])*((ratio-share[i-1])/(share[i]-share[i-1]));
  i=i+1;  end;
country=country_vec[1];
create output_bound var {y_perc country};append ;close output_bound;quit;run;
%mend;

data working; set lux_all;
country='LU';
pid=RB030;
w=RB050;
eqinc=HX090;
run;

%stat1;
proc means data=jrr;
var z;
weight w;
where subpop_i eq 1;
run;


proc means data=working1;
var hx080 z;
weight w;
run;


